/*
  A obesidade no  mais apenas um problema esttico, o excesso de peso pode
  provocar o surgimento de vrios problemas de sade como diabetes, problemas
  cardacos e a m formao do esqueleto.
  Item (a):
  O ndice de massa corporal (IMC)  uma medida internacional usada para calcular
  obesidade, adotada pela Organizao Mundial de Sade (OMS). O IMC  calculado
  pela seguinte frmula:
                        IMC = peso/(altura*altura)
  Onde a massa est em quilogramas e a altura est em metros. Faa uma funo que
  calcula o IMC e que retorna o grau de obesidade do indivduo segundo a tabela
  abaixo:
  IMC               Grau
    < 18,5          -1 (abaixo do peso)
    18,5 - 29,9     0 (normal)
    30,0 - 34,9     1 (obesidade grau I)
    35,0  39,9     2 (obesidade grau II)
    > 40,0          3 (obesidade grau III)

  Use o prottipo abaixo:
                          int GrauObesidade(float massa, float altura);
  Item (b):
  Em uma pesquisa foram coletados os seguintes dados de uma populao: Sexo
  (ex: M ou F), idade (ex: 25 anos), altura (ex: 1.7 m) e peso (ex: 75.5 Kg).
  Dado um arquivo texto pesquisa.txt que possui em sua primeira linha um
  inteiro que indica a quantidade de pessoas entrevistadas, e nas demais linhas
  os dados da pesquisa (um entrevistado por linha), conforme o exemplo:
  3
  M 25 1.70 75.5
  F 8 1.50 50.4
  M 15 1.63 62.7
  Escreva um programa que:
  Defina uma estrutura para armazenar os dados de cada entrevistado.
  Aloque dinamicamente um vetor de estruturas e preencha-o com os valores lidos
   do arquivo pesquisa.txt.
  Calcule o nmero de crianas obesas (grau maior ou igual a 1). Considere como
   crianas as pessoas com idade menor que 13 anos. Dica: utilize a funo do
   item (a).
  Crie um arquivo texto homens.txt que contm somente os dados das pessoas do
  sexo masculino entrevistadas. Obs: A primeira linha do arquivo deve conter o
  nmero de registros e as demais os dados (um registro por linha).
  Desaloque o vetor e feche os arquivos.
*/

#include <iostream>
#include <fstream>
#include <stdlib.h>

using namespace std;

typedef struct
{
    char sexo;
    int idade;
    double altura;
    double peso;
} dado;

int GrauObesidade(double massa, double altura)
{
    double imc = massa/(altura * altura);
    int res;

    if(imc <= 18.5)
        res = -1;
    else if (imc > 18.5 && imc < 30)
        res = 0;
    else if (imc >= 30 && imc < 35)
        res = 1;
    else if (imc > 35 && imc <= 40)
        res = 2;
    else
        res = 3;

    return res;
}

int main()
{
    dado *dados;
    int qtd;
    int criancasObesas = 0,
        homens = 0;

    fstream arquivo, arqhomens;

    arquivo.open("pesquisa.txt");
    arquivo >> qtd;

    dados = (dado *) malloc(sizeof(dado) * qtd);

    for(int j = 0; j < qtd; j++)
    {
        arquivo >> dados[j].sexo;
        arquivo >> dados[j].idade;
        arquivo >> dados[j].altura;
        arquivo >> dados[j].peso;
        //cout << dados[j].sexo << dados[j].idade << dados[j].peso;

        if(dados[j].sexo == 'M')
            homens++;
    }
    arquivo.close();

    for(int j = 0; j < qtd; j++)
    {
        if(dados[j].idade < 13)
        {
            if(GrauObesidade(dados[j].peso, dados[j].altura)  >= 1)
                criancasObesas++;
        }
    }

    cout << "O numero de criancas obesas e: " << criancasObesas << endl;

    arqhomens.open("homens.txt", ios::out | ios::trunc);
    arqhomens << homens << endl;

    for(int j = 0; j < qtd; j++)
    {
        if(dados[j].sexo == 'M')
        {
                arqhomens << dados[j].sexo << " "
                << dados[j].idade << " "
                << dados[j].altura << " "
                << dados[j].peso << endl;
        }
    }

    arqhomens.close();
    free(dados);
    return 0;
}
